<%@ Page Language="C#" enableViewState="false" %>
<%@ Import Namespace="System"%>
<%@ Import Namespace="System.Xml"%>
<%@ Import Namespace="System.Text"%>
<%@ Import Namespace="System.Net"%>
<%@ Import Namespace="System.Web.Services.Protocols"%>
<%@ Import Namespace="Microsoft.Crm.Platform.Proxy"%>
<HTML>
	<HEAD>
		<title>Copying Address Information...</title>
		<link rel="stylesheet" type="text/css" href="/_common/styles/select.css">
		<link rel="stylesheet" type="text/css" href="/_nav/tabs.css">
		<link rel="stylesheet" type="text/css" href="/_nav/nav.css">
		<link rel="stylesheet" type="text/css" href="/_nav/menu.css">
		<link rel="stylesheet" type="text/css" href="/_common/styles/global.css">
		<link rel="stylesheet" type="text/css" href="/_forms/styles/form.css">
		
		<script language="C#" runat="server">
		
		CUserAuth objUserAuth;
		string _strServerName;
		string _strUrl;
		
		void Page_Init()
		{
				string strObjectId = Request.QueryString["oId"].ToString();
				string strObjectType = Request.QueryString["oType"].ToString();
				string strObjectXml = "", nameString = "", companyName = "";
				if (ConfigurationSettings.AppSettings["CRMServer"] == null) 
					throw new ArgumentNullException("CRMServer", "The CRMServer key is missing from the web.config file or is empty.");

				_strServerName = ConfigurationSettings.AppSettings["CRMServer"].ToString();
				_strUrl = "http://" + _strServerName +  "/mscrmservices/" ;

				BizUser objCurrentUser = new BizUser();
				objCurrentUser.Credentials = CredentialCache.DefaultCredentials;
				objCurrentUser.Url = _strUrl + "BizUser.srf";
				objUserAuth = objCurrentUser.WhoAmI();

				strObjectXml = RetrieveObjectXml(Int16.Parse(strObjectType), strObjectId, objUserAuth);
				
				nameString = RetrieveNameXml (Int16.Parse(strObjectType), strObjectId, objUserAuth, strObjectXml);
				companyName = RetrieveCompanyName (Int16.Parse(strObjectType), strObjectId, objUserAuth, strObjectXml);
			
				if (strObjectXml != "") {
					CopyToClipboard(strObjectXml, nameString + companyName);
				}
		}
		
		// This function will return the string containing only name information.
		// Required because we need the name information of the Primary Contact of Account
		// and the name information of Contact and Lead directly.		
		string RetrieveNameXml (int iObjectType, string strObjectId, CUserAuth objUserAuth, string objectXml) {
			XmlDocument objXmlDoc = new XmlDocument();
			string xmlPrefixString;
			if ( iObjectType == 1 )  { // Account
				//Get the primary contact
				CRMAccount objAcc = new CRMAccount();
				objAcc.Credentials = CredentialCache.DefaultCredentials;;
				objAcc.Url = _strUrl + "CRMAccount.srf";
				string contactXml = "";
				try  {
					contactXml = objAcc.GetPrimaryContact(objUserAuth, strObjectId);
					xmlPrefixString = "//contact/";
					objXmlDoc.LoadXml (contactXml);
				} 
				catch (Exception e){
					return "";
				}
			}
			else  { // Contact and Lead
				xmlPrefixString = "//resultset/result/";
				objXmlDoc.LoadXml (objectXml);
			}
			// If it is account, we wi
			XmlNode currNode = objXmlDoc.SelectSingleNode (xmlPrefixString + "salutation");
			string addressText = "";
			if ( currNode != null )
				addressText += currNode.InnerText + " ";
			currNode = objXmlDoc.SelectSingleNode (xmlPrefixString + "firstname");
			if ( currNode != null )
				addressText += currNode.InnerText + " ";
			currNode = objXmlDoc.SelectSingleNode (xmlPrefixString + "middlename");
			if ( currNode != null )
				addressText += currNode.InnerText + " ";
			currNode = objXmlDoc.SelectSingleNode (xmlPrefixString + "lastname");
			if ( currNode != null )
				addressText += currNode.InnerText;
				
			if (addressText.Length > 0 )
				addressText += "\\n";
				
			return addressText;
		}			

		// Get the company name
		string RetrieveCompanyName(int iObjectType, string strObjectId, CUserAuth objUserAuth, string objectXml) {
			string companyName = "";
			if (iObjectType == 1 )  { //account
				XmlDocument accXmlDoc = new XmlDocument();
				accXmlDoc.LoadXml ( objectXml);
				XmlNode currNode = accXmlDoc.SelectSingleNode ("/resultset/result/name");
				if ( currNode != null )
					companyName += currNode.InnerText + "\\n";
			}
			else if (iObjectType == 2) { //contact
				XmlDocument objXmlDoc = new XmlDocument();
				objXmlDoc.LoadXml (objectXml);
				XmlNode currNode = objXmlDoc.SelectSingleNode ("/resultset/result/accountid");
				if ( currNode != null )  {// Retrieve the accountid and then the account name
					string accid = currNode.InnerText;
					CRMAccount objAcc = new CRMAccount();
					objAcc.Credentials = CredentialCache.DefaultCredentials;;
					objAcc.Url = _strUrl + "CRMAccount.srf";
					string accXml = objAcc.Retrieve(objUserAuth, accid,"");
					XmlDocument accDoc = new XmlDocument();
					accDoc.LoadXml (accXml);
					XmlNode nameNode = accDoc.SelectSingleNode ("//account/name");
					if (nameNode != null)  {
						companyName += nameNode.InnerText + "\\n";
					}
				}
			}
			else if (iObjectType == 4)  {//lead
				XmlDocument objXmlDoc = new XmlDocument();
				objXmlDoc.LoadXml (objectXml);
				XmlNode currNode = objXmlDoc.SelectSingleNode ("/resultset/result/companyname");
				if ( currNode != null )
					companyName += currNode.InnerText + "\\n";
			}

			return companyName;
		}
		
		string RetrieveObjectXml (int iObjectType, string strObjectId, CUserAuth objUserAuth) {
			string fetchXml = "<fetch mapping='logical'><entity name=";			
			switch(iObjectType) {         
				case 1:         
					fetchXml += @"'account'><all-attributes/><filter type='and'><condition attribute = 'accountid' operator='eq'
								value='" + strObjectId +  "'/></filter></entity></fetch>";
					break;
			
				case 2:
					fetchXml += @"'contact'><all-attributes/><filter type='and'><condition attribute = 'contactid' operator='eq'
								value='" + strObjectId +  "'/></filter></entity></fetch>";
					break;
				
			
				case 4:
					fetchXml += @"'lead'><all-attributes/><filter type='and'><condition attribute = 'leadid' operator='eq'
								value='" + strObjectId +  "'/></filter></entity></fetch>";
					break;
			}

			CRMQuery objQuery = new CRMQuery();
			objQuery.Credentials = CredentialCache.DefaultCredentials;
			objQuery.Url = _strUrl + "CRMQuery.srf";
			return objQuery.ExecuteQuery(objUserAuth, fetchXml);
		}
		
		void CopyToClipboard (string objectXml, string nameString)  {
			// Get the address information from the xml
			string addressText = nameString;
			XmlDocument objXmlDoc = new XmlDocument ();
			objXmlDoc.LoadXml (objectXml);
			
			XmlNode currNode = objXmlDoc.SelectSingleNode ("/resultset/result/address1_line1");
			if ( currNode != null )
				addressText += currNode.InnerText;
			currNode = objXmlDoc.SelectSingleNode ("/resultset/result/address1_line2");
			if ( currNode != null )
				addressText += ", " + currNode.InnerText;				
			currNode = objXmlDoc.SelectSingleNode ("/resultset/result/address1_line3");
			if ( currNode != null )
				addressText += ", " + currNode.InnerText;
			addressText += "\\n";				
			currNode = objXmlDoc.SelectSingleNode ("/resultset/result/address1_city");
			if ( currNode != null )
				addressText += currNode.InnerText + ",";				
			currNode = objXmlDoc.SelectSingleNode ("/resultset/result/address1_stateorprovince");
			if ( currNode != null )
				addressText += " " + currNode.InnerText + " ";				
			currNode = objXmlDoc.SelectSingleNode ("/resultset/result/address1_postalcode");
			if ( currNode != null )
				addressText += " " + currNode.InnerText;
			addressText += "\\n";				
			currNode = objXmlDoc.SelectSingleNode ("/resultset/result/address1_country");
			if ( currNode != null )
				addressText += currNode.InnerText;				
			
			// pass the info to the clipboard
			Response.Write ( "<script>window.clipboardData.setData('Text', \"" + addressText + "\");<" + "/script>" );
		}

		</script>
	</HEAD>
	<body>
		<table cellspacing="0" cellpadding="0" width="100%" height=100%>
			<tr>
				<td width="100%" valign=top>
					<table cellspacing="0" cellpadding="5" class="mnubar">
						<tr  align=left>
							<td align="left" class="mnuTitle mnuLeft">The Address information has been copied into the clipboard.</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr height=20%><td>&nbsp;</td></tr>
			<tr>
									<td align="center"><button onclick="window.close()" title="Close the window">Close</button></td>
			</tr>
		</table>
	</body>
</HTML>
